#
#     ll.mak 
#
#     Makefile for xll.lib and lltest.exe where x is a memory 
#     model code (S,M,C,L).
#
#     This makefile works with make, nmake, and nmk, and the 
#     Microsoft C 5.1 and C 6.0 compilers.
#
MODEL  = S
CFLAGS = /Za /Zip /A$(MODEL) /Od /W3
NOLINK = /c
OBJLIB = $(MODEL)ll.lib

#
#  make will deliver a warning on this line, but is required for 
#  nmake and nmk to work properly...
#
all : lltest.exe

llbase.obj : llbase.c ll.h
   cl $(NOLINK) $(CFLAGS) llbase.c
   lib $(OBJLIB) -+llbase.obj;

llprim.obj : llprim.c ll.h
   cl $(NOLINK) $(CFLAGS) llprim.c
   lib $(OBJLIB) -+llprim.obj;

llins.obj  : llins.c ll.h
   cl $(NOLINK) $(CFLAGS) llins.c
   lib $(OBJLIB) -+llins.obj;

llswap.obj : llswap.c ll.h
   cl $(NOLINK) $(CFLAGS) llswap.c
   lib $(OBJLIB) -+llswap.obj;

llsort.obj : llsort.c ll.h
   cl $(NOLINK) $(CFLAGS) llsort.c
   lib $(OBJLIB) -+llsort.obj;

lltest.obj : lltest.c
   cl $(NOLINK) $(CFLAGS) lltest.c 

$(OBJLIB) : llbase.obj llprim.obj llins.obj llswap.obj llsort.obj 

lltest.exe : lltest.obj $(OBJLIB) ll.h
   link /CO /NOE lltest.obj,lltest.exe,,$(OBJLIB);


